#
# Revision of bpack.py to use RangeSet's
#
import sys
import sets
from coopr.pyomo import *


model = Model()
#
# Parameter N
#
model.N = Param(within=Integers)
#
# Set I
#
model.I = RangeSet(1,model.N)
#
# Variable b
#
model.b = Var(model.I, domain=Boolean)
#
# Objective zot
#
def costrule(model):
	ans = 0
	for i in model.I:
		ans += (1 + .02*i)*model.b[i]
	return ans
model.zot = Objective(rule=costrule, sense=maximize)
#
# Parameter w
#
#def w_init(model):
#	ans = sets.Set()
#	i = 1
#	N9 = model.N - 9
#	while i <= N9:
#		j = i
#		i9 = i + 9
#		while j <= i9:
#			ans.add((i,j))
#			j += 1
#		i += 1
#	return ans
##i in 1 .. N - 9, j in i .. i + 9
def w_test(i,j,model):
  if i<1 or i>value(model.N):
     return False
  if j<i or j>i+9:
     return False
  return True
model.w = Param(RangeSet(1,model.N),RangeSet(1,model.N), validate=w_test)
#
# Set rhs_ind
#
model.rhs_ind = RangeSet(1,model.N-9)
#
# Parameter rhs
#
model.rhs = Param(model.rhs_ind)
#
# Constraint bletch
#
def bletch_rule(i,model):
	ans = 0
	j = i
	i9 = i + 9
	while j <= i9:
		ans += model.w[i,j]*model.b[j]
		j += 1
	ans = ans < model.rhs[i]
	return ans
model.bletch = Constraint(model.rhs_ind, rule=bletch_rule)
